use based::auth::User;
use based::get_pg;
use rocket::routes;

pub mod routes;

#[rocket::launch]
async fn launch() -> _ {
    env_logger::init();

    let pg = get_pg!();
    sqlx::migrate!("./migrations").run(pg).await.unwrap();

    let _ = User::create("admin".to_string(), "admin", based::auth::UserRole::Admin).await;

    rocket::build().mount("/", routes![
        based::htmx::htmx_script_route,
        routes::index_page,
        routes::pkg_route,
        routes::push::upload_pkg,
        routes::user::login,
        routes::user::login_post,
        routes::user::account_page,
        routes::ui::pkg_ui,
        routes::ui::repo_ui,
        routes::user::new_api_key,
        routes::user::end_session,
        routes::user::change_password,
        routes::user::change_password_post
    ])
}
